#include <stdio.h>
#include <stdlib.h>
#include <dos.h>


#define LOW_FILTER	0
#define HIGH_FILTER	1
#define NO_FILTER	2

#define SOURCE_MIC1	0
#define SOURCE_CD	1
#define SOURCE_MIC2	2
#define SOURCE_LINE	3

#define MONO	0
#define STEREO	1

#define USE_FILTER	0
#define BYPASS_FILTER	1

int	bases[4]={ 0x220, 0x230, 0x240, 0x250, };
int	baseAddrSB=0x220;


	// 

unsigned char pascal sbRead
	( void )
{
asm	mov	dx,	0eh;
asm	add	dx,	baseAddrSB;
W1:
asm	in	al,	dx;
asm	or	al,	al;
asm	jns	W1;

asm	sub	dx,	4;
asm	in	al,	dx;
return (char)_AL;
}

	// ஢ 稥
	
char pascal sbCheck
	( void )
{
int i, j;
for ( j=0; j<4; j++ )
{
baseAddrSB=bases[j];
outportb(baseAddrSB+6,1);
delay(10);
outportb(baseAddrSB+6,0);
delay(10);
for(i=0; i<30000; i++ )
	if ( sbRead()==0xAA )
		return 1;
}
return 0;
}


void	sbWriteMixer
	( char index, char val )
{
outportb(baseAddrSB+4,index);
outportb(baseAddrSB+5,val);
}


char	sbReadMixer
	( char index )
{
outportb(baseAddrSB+4,index);
return inportb(baseAddrSB+5);
}

void	sbResetMixer
	( void )
{
sbWriteMixer(0,0); // RESET
}


void	sbInputMixer
	( char sou, char filtr )
{
char val;
val=(sou<<1)&0x6;
val|=(filtr<<3)&0x38;
sbWriteMixer(0xC,val);
}


void	sbOutputMixer
	( char st, char filtr )
{
char val;
val=(st==1)?2:0;
val|=(filtr==1)?0x20:0;
sbWriteMixer(0xE,val);
}


void	sbMasterVolume
	( char left, char right )
{
char val;
val=right&0xf;
val|=(left<<4)&0xf0;
sbWriteMixer(0x22,val);
}

void	sbVoiceVolume
	( char left, char right )
{
char val;
val=right&0xf;
val|=(left<<4)&0xf0;
sbWriteMixer(0x04,val);
}

void	sbFMVolume
	( char left, char right )
{
char val;
val=right&0xf;
val|=(left<<4)&0xf0;
sbWriteMixer(0x26,val);
}

void	sbCDVolume
	( char left, char right )
{
char val;
val=right&0xf;
val|=(left<<4)&0xf0;
sbWriteMixer(0x28,val);
}

void	sbLineVolume
	( char left, char right )
{
char val;
val=right&0xf;
val|=(left<<4)&0xf0;
sbWriteMixer(0x2E,val);
}


void	sbMicVolume
	( char vol )
{
char val;
val=vol&0x7;
sbWriteMixer(0xA,val);
}

void	main
	( int argc, char * argv[] )
{
char level_master=8, level_voice=0, level_fm=0,  level_cd=0, i;
char ch;

if ( sbCheck()!=1 ) return;

if ( argc<2 )
{
	printf("Volume: M(aster)N  V(oice)N  F(M)N  C(D)N\n");
	printf("N = 0 - min, 15 - max\n");
	return;
}

for ( i=1; i<argc; i++ )
{
	ch=argv[i][0]; argv[i][0]=' ';
	switch ( ch )
	{
	case 'M': case 'm': level_master=atoi(argv[i]); break;
	case 'V': case 'v': level_voice=atoi(argv[i]); break;
	case 'F': case 'f': level_fm=atoi(argv[i]); break;
	case 'C': case 'c': level_cd=atoi(argv[i]); break;
	}
}

if ( level_master>15 || level_master<0 ) level_master=8;
if ( level_voice>15 || level_voice<0 ) level_voice=0;
if ( level_fm>15 || level_fm<0 ) level_fm=0;
if ( level_cd>15 || level_cd<0 ) level_cd=0;
sbResetMixer();
sbMasterVolume(level_master,level_master);
sbVoiceVolume(level_voice,level_voice);
sbFMVolume(level_fm,level_fm);
sbCDVolume(level_cd,level_cd);
printf("Master=%d, Voice=%d, FM=%d, CD=%d\n",
	level_master,level_voice,level_fm,level_cd);
}
